﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class GameManager : MonoBehaviour {
	private Color currentColor = new Color (0, 0, 0);
	private int correctAnswer = 0;
	private List<GameObject> answers = new List<GameObject> ();
	private Vector3 questionPos;
	private Vector3 questionRot;
	public Image question;
	public Image AnswerTemplate;
	public Transform answerGroup;
	void Start () {
		questionPos = question.transform.localPosition;
		questionRot = question.transform.localEulerAngles;
		ResetMe ();
	}

	void Update () {
		
	}

	public void ResetMe()
	{
		float newX = Random.Range (-350f, 350f);
		float newY = Random.Range (200f, 450f);
		float newR= Random.Range (90f,359f);
		Vector3 newPos = new Vector3 (questionPos.x + newX, questionPos.y + newY);
		Vector3 newRot = new Vector3 (questionRot.x, questionRot.y, questionRot.z + newR);
		StartCoroutine (moveQuestion (newPos,newRot));
		for (int i2 = 0; i2 < answers.Count; i2++) {
			Destroy (answers [i2]);
		}
		answers.Clear ();
		float r = Random.Range (0f, 1f);
		float g = Random.Range (0f, 1f);
		float b = Random.Range (0f, 1f);
		currentColor = new Color (r, g, b);
		question.color = currentColor;

		int answerCount = Random.Range (3, 7);

		for (int i = 0; i < answerCount; i++) {
			GameObject newAnswer = (GameObject)Instantiate (AnswerTemplate.gameObject, answerGroup);
			newAnswer.SetActive (true);
			float r2 = Random.Range (-0.10f, 0.10f);
			float g2 = Random.Range (-0.10f, 0.10f);
			float b2 = Random.Range (-0.10f, 0.10f);
			Color similiarColor = new Color(
				currentColor.r + r2,
				currentColor.g + g2,
				currentColor.b + b2
			);
			newAnswer.GetComponent<Image>().color = similiarColor;
			int x = i;
			newAnswer.GetComponent<Button> ().onClick.AddListener ( ()=> {TestMe(x);} );
			answers.Add (newAnswer);
		}
		correctAnswer = Random.Range (0, answerCount);
		answers[correctAnswer].GetComponent<Image>().color = currentColor;
	}

	public IEnumerator moveQuestion(Vector3 pos, Vector3 rot)
	{
		float elapsedTime = 0;
		while (elapsedTime < 1.5f) {
			Color zeroAlpha = new Color (question.color.r, question.color.g, question.color.b, 0f);
			Color fullAlpha = new Color (question.color.r, question.color.g, question.color.b, 1f);
			question.color = Color.Lerp (zeroAlpha, fullAlpha, elapsedTime / 1);
			question.transform.localPosition = Vector3.Lerp (pos, questionPos, elapsedTime / 1);
			question.transform.localEulerAngles = Vector3.Lerp (rot, questionRot, elapsedTime / 1);
			elapsedTime += Time.deltaTime;
			yield return null;
		}
	}

	public void TestMe(int value)
	{
		Debug.Log (value);
		if (value == correctAnswer) {
			ResetMe ();
		} else {
			Debug.Log("Incorrect!");
		}
	}
}
